SystemOrganization addCategory: #SpecDuplicationInspector!

NullTextStyler subclass: #DuplicationTextHighlighter
	instanceVariableNames: 'start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpecDuplicationInspector'!

!DuplicationTextHighlighter methodsFor: 'accessing' stamp: 'ub 11/22/2012 16:04'!
end
	^ end! !

!DuplicationTextHighlighter methodsFor: 'accessing' stamp: 'ub 11/22/2012 16:04'!
end: anObject
	end := anObject! !

!DuplicationTextHighlighter methodsFor: 'formatting' stamp: 'ub 11/22/2012 16:33'!
format: aText
	^aText  addAttribute: (TextColor color: Color orange) from: (aText string intervalOfLine: self start) first to: (aText string intervalOfLine: self end) last.! !

!DuplicationTextHighlighter methodsFor: 'accessing' stamp: 'ub 11/22/2012 18:30'!
initialize
	start := 60.
	end := 70.! !

!DuplicationTextHighlighter methodsFor: 'accessing' stamp: 'ub 11/22/2012 16:04'!
start
	^ start! !

!DuplicationTextHighlighter methodsFor: 'accessing' stamp: 'ub 11/22/2012 16:04'!
start: anObject
	start := anObject! !

ComposableModel subclass: #CloneFileWidget
	instanceVariableNames: 'codeText label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpecDuplicationInspector'!

!CloneFileWidget class methodsFor: 'as yet unclassified' stamp: 'ub 11/7/2012 19:02'!
defaultSpec
	<spec: #default>
	^ SpecLayout composed 
			newColumn: [:c | c add: #label height: 20; add: #codeText]
		yourself.! !

!CloneFileWidget class methodsFor: 'as yet unclassified' stamp: 'ub 11/17/2012 12:45'!
run
	(CloneFileWidget new label: 'adsasda';
	openWithSpec;
	yourself)! !

!CloneFileWidget methodsFor: 'accessing' stamp: 'ub 11/6/2012 16:53'!
codeText 
	^codeText! !

!CloneFileWidget methodsFor: 'accessing' stamp: 'ub 11/22/2012 16:56'!
codeText: aString
	codeText text: aString asText.! !

!CloneFileWidget methodsFor: 'initialization' stamp: 'ub 11/27/2012 17:41'!
hightlightInterval
	codeText widget styler: DuplicationTextHighlighter new.
	codeText aboutToStyle: true.
	codeText widget selectionInterval: 5000@6000.
	codeText widget scrollSelectionIntoView; changed.! !

!CloneFileWidget methodsFor: 'initialization' stamp: 'ub 11/22/2012 18:31'!
hightlightInterval: anInterval
	codeText widget styler: DuplicationTextHighlighter new.
	codeText aboutToStyle: true.
	self halt.
	codeText widget scrollSelectionIntoView; changed.
	! !

!CloneFileWidget methodsFor: 'initialization' stamp: 'ub 11/22/2012 17:06'!
initializeWidgets
	self instantiateModels: { 
		#label  -> #LabelModel.
		#codeText -> #TextModel
		 }.
	label color: Color blue.! !

!CloneFileWidget methodsFor: 'accessing' stamp: 'ub 11/6/2012 16:53'!
label
	^label! !

!CloneFileWidget methodsFor: 'accessing' stamp: 'ub 11/7/2012 15:07'!
label: aString
	label text: aString! !

DynamicComposableModel subclass: #SpecDuplicationInspectorDynamic
	instanceVariableNames: 'cloneFragmentsTree dropList listLabel selectedItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpecDuplicationInspector'!

!SpecDuplicationInspectorDynamic class methodsFor: 'as yet unclassified' stamp: 'ub 11/16/2012 13:57'!
aLayout
	<spec: #default>
	^ DupInspectorLayout initialLayout.! !

!SpecDuplicationInspectorDynamic class methodsFor: 'as yet unclassified' stamp: 'ub 11/15/2012 16:10'!
inputRoots
	^ (TaggedList new entities: {1. 2. 3}; getListOfEntities)! !

!SpecDuplicationInspectorDynamic class methodsFor: 'as yet unclassified' stamp: 'ub 11/14/2012 15:09'!
run
	(SpecDuplicationInspectorDynamic new
	openWithSpec;
	yourself)
		cloneFragmentsTree  roots: self inputRoots.! !

!SpecDuplicationInspectorDynamic methodsFor: 'redraw' stamp: 'ub 11/16/2012 13:54'!
clearContainer
	| name |
	selectedItems := OrderedCollection new.
	self rebuildBrowserWithSpec: DupInspectorLayout initialLayout.
	
	! !

!SpecDuplicationInspectorDynamic methodsFor: 'menu' stamp: 'ub 11/13/2012 16:22'!
cloneMenu: aMenu
	aMenu target: self.

	aMenu addList: #(
			('Explore all files'	exploreAllFiles)).
	^aMenu! !

!SpecDuplicationInspectorDynamic methodsFor: 'redraw' stamp: 'ub 11/22/2012 17:08'!
createFileContainers
	| newName |
	1 to: self selectedItems size do: [:idx |
		newName := ('col', idx asString) asSymbol.
		self instantiateModels: { newName.  #CloneFileWidget }.
		self moduleTextFor: self cloneFragmentsTree selectedItem inPaneNamed: newName.
		].
		
		self rebuildBrowserWithSpec: self dynSpecLayout.
		
		1 to: self selectedItems size do: [:idx |
		newName := ('col', idx asString) asSymbol.
		(self perform: newName) hightlightInterval.
		].
		! !

!SpecDuplicationInspectorDynamic methodsFor: 'initialization' stamp: 'ub 11/15/2012 18:14'!
dropListItems
	| items |
	items := OrderedCollection new.
	items add: (DropListItem named: 'All Clones' do: self emptyMethod).
	items add: (DropListItem named: 'To do' do: self emptyMethod).
	^ items! !

!SpecDuplicationInspectorDynamic methodsFor: 'layouts' stamp: 'ub 11/16/2012 13:54'!
dynSpecLayout
	^ DupInspectorLayout dynSpecLayoutWith: selectedItems.! !

!SpecDuplicationInspectorDynamic methodsFor: 'initialization' stamp: 'ub 11/15/2012 18:16'!
emptyMethod
	^[]! !

!SpecDuplicationInspectorDynamic methodsFor: 'menu' stamp: 'ub 11/15/2012 12:50'!
exploreAllFiles

	self selectedItems removeAll.
	self selectedItems add: 1; add: 2.
	self redrawBrowser.! !

!SpecDuplicationInspectorDynamic methodsFor: 'initialization' stamp: 'ub 11/13/2012 16:22'!
initialExtent

	^ (1100) @ (900)! !

!SpecDuplicationInspectorDynamic methodsFor: 'initialization' stamp: 'ub 11/15/2012 12:53'!
initializePresenter
	self cloneFragmentsTree whenSelectedItemChanged: [:anItem|
		self updateTitle.
		self cloneFragmentsTree menu: [:menu :shifted | self cloneMenu: menu ].
		self clearContainer.
	].
	! !

!SpecDuplicationInspectorDynamic methodsFor: 'initialization' stamp: 'ub 11/17/2012 12:54'!
initializeWidgets

	self instantiateModels: #(
		cloneFragmentsTree TreeModel
		dropList DropListModel
		listLabel LabelModel
		fileContainer CloneFileWidget).
	self cloneFragmentsTree displayBlock: [:item | 
			item isNumber ifTrue: [item name] ifFalse: [item]].
	self listLabel text: 'Clones'.
	self dropList items: self dropListItems.
	self cloneFragmentsTree childrenBlock: [:item | 
						(item isKindOf: AlignmentMorph)
						ifTrue: [{(1) asString. (2) asString} collect: [:e | self wrap: e]]
						ifFalse: [{}]].! !

!SpecDuplicationInspectorDynamic methodsFor: 'menu' stamp: 'ub 11/15/2012 11:27'!
moduleMenu: aMenu shifted: shifted
	aMenu target: self.
	aMenu addList: #(
			('Explore Program'	#createFileContainers)).
	^ aMenu! !

!SpecDuplicationInspectorDynamic methodsFor: 'text' stamp: 'ub 11/22/2012 17:07'!
moduleTextFor: aModuleName inPaneNamed: newName
	| model module |
	(self perform: newName) label: 'aModuleName'.
	(self perform: newName) codeText: self text asText.
	! !

!SpecDuplicationInspectorDynamic methodsFor: 'redraw' stamp: 'ub 11/14/2012 19:52'!
rebuildBrowserWithSpec: aSpecLayout
	self needFullRebuild: false.
	self needRebuild: false.
	self cloneFragmentsTree needRebuild: false.
	self buildWithSpecLayout: aSpecLayout! !

!SpecDuplicationInspectorDynamic methodsFor: 'redraw' stamp: 'ub 11/16/2012 13:54'!
redrawBrowser

	(selectedItems size > 0)
		ifTrue: [self createFileContainers ]
		ifFalse: [ self rebuildBrowserWithSpec: DupInspectorLayout initialLayout. ]
	! !

!SpecDuplicationInspectorDynamic methodsFor: 'accessing' stamp: 'ub 11/14/2012 18:59'!
selectedItems
	^ selectedItems ifNil: [selectedItems := OrderedCollection new ]! !

!SpecDuplicationInspectorDynamic methodsFor: 'text' stamp: 'ub 11/14/2012 17:18'!
text
	^'   10  ENTRY DLPRTN02_PRIFIGEE(NUM_POL,DT_EFFET_MOD,PGM_APPELANT,NEW_PRI_COMM,
   20  .''NEW_CAPIT,NEW_RENTE,SW_LECT_DB,SW_MAJ_DB,BASE_TECHNIQUE_IN,CHG_E,
   21  .''CHG_G,CHG_P,CHG_F,FRAC_PRIME,DT_EFFET_SEG_HSPLC,TAUX_PRI_RET,CD_ERREUR)
   22  .!!***********************************************************************
   23  .!! ROUTINE DLPRTN02 (NORMALEMENT CAPITAL FIGE) APPELEE EN CAS DE
   24  .!! LIMITATION DE CAPITAL DANS UNE POLICE A PRIME FIGEE              D.H.
   25  .!! APPELEE DANS LES PLANS OU ON A FAIT APPEL, PRECEDEMMENT, A DLPRTN01 :
   26  .!! - DLPLA2739R
   27  .!! PRINCIPE : LECTURE DU DERNIER SEGMENT HSPLC 999 QUI CORRESPOND A LA
   28  .!! 20120321   BASE TECHNIQUE EN VIGUEUR - PASSEE EN PARAMETRE - ET MISE
   29  .!!            A JOUR DE LA TABLE HIST_POLICE 999 ET DU DERNIER SEGMENT
   30  .!!            HSPLC 999 LU AVEC LES NOUVELLES PRIMES FIGEES (INVENTAIRE
   31  .!!            ET COMMERCIALE) ET LE NOUVEAU CAPITAL                 D.H.
   32  .!! 20120322 : A PROGRAMMER APRES LA MISE EN PRODUCTION
   34  .!!            + PARCOURIR TOUS LES AUTRES SEGMENTS HSPLC SUIVANTS
   35  .!!            (S''IL Y A EU DES SEGMENTS REDUITS EN CAS DE DIMINUTION)
   36  .!!            ET LES INCREMENTER TANT QUE LA PRIME INVENTAIRE RESTE >
   37  .!!            A LA PRIME FIGEE                                       D.H.
   38  .!! ATTENTION : CETTE PARTIE N''EST PAS ENCORE PROGRAMMEE (VOIR CE QUI
   39  .!!             A ETE FAIT - SANS ETRE TESTE - DANS DLPRTN01_CAPFIGE) D.H.
   40  .!!***********************************************************************
  140  .!!COMMIT OFF
  141  .SHOW"DLPRTN02_PRIFIGEE ... POLICE ";NUM_POL;"/"
  143  .SHOW"DT_EFFET_MOD ";DT_EFFET_MOD
  144  .SHOW"NEW_PRI_COMM ";NEW_PRI_COMM
  145  .SHOW"NEW_CAPIT ";NEW_CAPIT
  146  .SHOW"NEW_RENTE ";NEW_RENTE
  147  .SHOW"SW_LECT_DB ";SW_LECT_DB
  148  .SHOW"SW_MAJ_DB ";SW_MAJ_DB
  149  .SHOW"BASE_TECHNIQUE_IN ";BASE_TECHNIQUE_IN
  150  .SHOW" CHG E ";CHG_E;" G ";CHG_G;" P ";CHG_P;" F ";CHG_F
  151  .SHOW"FRAC PRIME=";FRAC_PRIME
  152  .SHOW"DT EFFET SEG HSPLC=";DT_EFFET_SEG_HSPLC
  153  .SHOW"TAUX PRI RET=";TAUX_PRI_RET
  154  .SHOW"CD_ERREUR ";CD_ERREUR
  155  .WAIT
  156  .!!VIEW RDX_DBAS("RDX_GFLX_DBAS")
  160  .!!VIEW RDX_RETA("RDX_GFLX_RETA")
  170  .!!VIEW RDX_RETC("RDX_GFLX_RETC")
  180  .!!VIEW RD_DOSSIER("RD_GROUPE_DOSSIER")
  190  .!!VIEW UPX_HIST_POLICE("UPX_GROUPE_HIST_POLICE")
  200  .!!VIEW DE_HIST_POLICE("DE_GROUPE_HIST_POLICE")
  210  .!!VIEW UPX_HIST_SPOLICE("UPX_GROUPE_HIST_SPOLICE")
  220  .!!VIEW AD_HIST_SPOLICE("AD_GROUPE_HIST_SPOLICE")
  230  .TEXT CODE_ERREUR(3)
  240  .TEXT PGM_APPELANT(15)
  250  .TEXT BASE_TECH_CALC(28)
  251  .TEXT BASE_TECHNIQUE_IN(28)
  260  .!!PROGRAM DLPRTAGE("DLPRTAGE","GROUPE")
  270  .!!PROGRAM DLPRTPER("DLPRTPER","GROUPE")
  280  .!!PROGRAM DLPRTECH("DLPRTECH","GROUPE")
  290  .!!PROGRAM DLPAPPNTX("DLPAPPNTX","GROUPE")
  300  .!!PROGRAM DLPRTBASE("DLPRTBASE","GROUPE")
  310  .!!PROGRAM DLPRTCONJ("DLPRTCONJ","GROUPE")
  320  .!!PROGRAM DLPRTVALB("DLPRTVALB","GROUPE")
  330  .!!PROGRAM DLPUP035("DLPUP035","GROUPE")
  340  .!!PROGRAM DLPRTCCR("DLPRTCCR","GROUPE")
  350  .!!!! TRAITEMENT
  360  .!!------------------------------------------------------------------
  370  .!!--   INIT ET APPEL ROUTINE GENDATE POUR DATE SYSTEME AN 2000
  380  .!!------------------------------------------------------------------
  390  .TEXT DATE_CHAR_2000(8),DATE_SLAMJ_2000(10),DATE_SLJMA_2000(10)
  400  .BIG DATE_NUM_2000
  410  .DATE_CHAR_2000="00000000"
  420  .DATE_SLAMJ_2000="0000000000"
  430  .DATE_SLJMA_2000="0000000000"
  440  .DATE_NUM_2000=0
  450  .ANNEE_N_2000=0
  460  .JOUR_N_2000=0
  470  .MOIS_N_2000=0
  480  .PROGRAM GENDATE("GENDATE","GROUPE")
  490  .DO GENDATE(DATE_CHAR_2000,ANNEE_N_2000,MOIS_N_2000,JOUR_N_2000,
  500  .''DATE_NUM_2000,DATE_SLAMJ_2000,DATE_SLJMA_2000)
  510  .RELEASE GENDATE
  520  .!!------------------------------------------------------------------
  530  .NUM_EMPL_TRTN02 ROUNDED(0)=NUM_POL/100000
  540  .NUM_EMPL_TRTN021=NUM_POL/100000
  550  .NUM_EMPL_TRTN022=NUM_EMPL_TRTN02-NUM_EMPL_TRTN021
  560  .IF NUM_EMPL_TRTN022>0
  570  ..NUM_EMPL_TRTN02=NUM_EMPL_TRTN02-1
  580  .END
  581  .!!
  582  .!! CALCULS DES ZONES HPLC SE TROUVENT DANS ROUTINE "RECALCUL_GLOBAL"
  583  .!! MAIS LECTURE DU SEGMENT HPLC 999 NECESSAIRE CAR DIFFERENTES ZONES DE
  584  .!! HPLC UTILISEES DANS "RECHERCHE_TAUX_PRIME"
  630  .DO CALCUL_DATA_POLICE
  631  .!!
  640  .CAPIT_VIE_REST=NEW_CAPIT
  650  .CAPIT_AVT_MODIF=0
  660  .TAUX_DEROG ROUNDED(5)=((1-CHG_E)*(1-CHG_G-CHG_P))/(1+CHG_F)
  661  .SHOW"TAUX DEROG=";TAUX_DEROG
  662  .WAIT
  670  .TOTAL_CAP_VIE=0
  680  .TOTAL_CAP_DEC=0
  690  .NEW_PRI_COMM=0
  700  .NEW_RENTE=0
  701  .!!
  702  .IF(CD_ERREUR=0)
  703  ..DO RECHERCHE_DERN_SEG_HSPLC_VIG
  704  .END
  705  .!!************************ A GARDER ? NON !!
  710  .!!DO RECHERCHE_DERN_SEG_VIG
  720  .!!DO RECHERCHE_BASE_TECH_VIG
  721  .!!
  722  .!! LECTURE DES SEGMENTS SUIVANTS SI NEW PRIME > PRIME FIGEE
  723  .!! (CAD SW_SUITE = 1)
  724  .!! 20120322 : A NE PAS PROGRAMMER POUR LA MISE EN PROD D''AVRIL 2012
  725  .!!
  726  .!!IF(CD_ERREUR=0)AND(SW_SUITE=1)
  727  .!!.PRIME_AVT_MODIF=0
  728  .!!.DO RECHERCHE_PRIME_AVT_MODIF
  729  .!!.DO BOUCLE_SPOLICE
  732  .!!END
  733  .!!SHOW" BOUCLE SPOLICE CAPITAL FIGE"
  734  .!!WAIT
  735  .!!************************ A GARDER ? NON!!
  760  .!!DO BOUCLE_SPOLICE_CAPITAL_FIGE
  791  .!!************************ A GARDER ? NON !!
  800  .!!DO BOUCLE_SPOLICE_CAPITVIE
  821  .!! RECALCUL_GLOBAL : GARNISSAGE DES ZONES HPLC
  822  .!!
  823  .!! GARNISSAGE DES ZONES HPLC
  824  .!!
  825  .IF(CD_ERREUR=0)
  830  ..DO RECALCUL_GLOBAL
  831  ..!!
  840  ..PRI_INV_ANN_REST=PRI_INV_ANN
  850  ..PRI_COMM_ANN_REST=PRI_COMM_ANN
  860  ..PRI_INV_FR_REST=PRI_INV_FRAC
  870  ..PRI_COMM_FR_REST=PRI_COMM_FRAC
  880  ..!!SHOW" $$$$$$$$$$$$ PRI_INV_ANN_REST (2) ";PRI_INV_ANN_REST
  890  ..!!SHOW" PRI COMM ANN REST ";PRI_COMM_ANN_REST
  900  ..!!SHOW" PRI_INV_FR_REST ";PRI_INV_FR_REST
  910  ..!!SHOW" PRI COMM FR REST ";PRI_COMM_FR_REST
  920  ..!!SHOW" AVANT BOUCLE SPOLICE PRIMES "
  930  ..!!WAIT
  931  ..!!************************ A GARDER ? APPAREMMENT NON (RECALCUL ARRONDIS)
  940  ..!!DO BOUCLE_SPOLICE_PRIMES
  968  ..!!IF SW_MAJ_DB=1
  971  ..!!.DO MAJ_DB
  972  ..!!END
  973  .END
  980  .!!RELEASE RDX_DBAS
  990  .!!RELEASE RDX_RETA
 1000  .!!RELEASE RDX_RETC
 1010  .!!RELEASE RD_DOSSIER
 1020  .DO RELEASE_UPX_HIST_POLICE
 1030  .DO RELEASE_UPX_HIST_SPOLICE
 1040  .!!RELEASE AD_HIST_SPOLICE
 1050  .!!RELEASE DE_HIST_POLICE
 1060  .!!RELEASE DLPRTAGE
 1070  .!!RELEASE DLPRTPER
 1080  .!!RELEASE DLPRTECH
 1090  .!!RELEASE DLPAPPNTX
 1100  .!!RELEASE DLPRTBASE
 1110  .!!RELEASE DLPRTCONJ
 1120  .!!RELEASE DLPRTVALB
 1130  .!!RELEASE DLPUP035
 1140  .!!RELEASE DLPRTCCR
 1150  EXIT
 2440  ENTRY RECHERCHE_TAUX_PRIME
 2450  .TEXT POS1_FRAC_REN(1)
 2460  .TEXT POS2_FRAC_REN(2)
 2470  .SMALL IMAX
 2480  .SMALL TABMAX
 2490  .IMAX=131
 2500  .TABMAX=4
 2510  .TEXT TABLES_NAME(4,12),TYPE_BASE(1),KEY_BASE(16)
 2520  .TEXT GARANTI_BASE(1),PUPP_BASE(1),CATEG_BASE(1)
 2530  .BIG TAUX_BT_OUT
 2540  .BIG LOUT(IMAX,TABMAX),DOUT(IMAX,TABMAX)
 2550  .BIG NOUT(IMAX,TABMAX),SOUT(IMAX,TABMAX)
 2560  .BIG COUT(IMAX,TABMAX),MOUT(IMAX,TABMAX)
 2570  .BIG ROUT(IMAX,TABMAX),VOUT(IMAX,TABMAX)
 2580  .BIG V(IMAX,TABMAX)
 2590  .CLEAR B2,B3,POURCQX,PUS_MM,ECR,REV,ARR,S1,CG
 2600  .CLEAR CAPITAL,PRICO,SOMME,SEX_X,SW_PUS,SEX_Y
 2610  .CLEAR TPUP,TPUI,TPUC,TPAP,TPAI,TPAC,ANN,RES,ABAR,IABAR
 2620  .TEXT BT_ECR(28)
 2630  .BT_ECR=BASE_TECH_CALC
 2640  .TYPE_BASE=BT_ECR(1,1)
 2650  .KEY_BASE=BT_ECR(2,16)
 2660  .GARANTI_BASE=BT_ECR(18,18)
 2670  .PUPP_BASE=BT_ECR(19,19)
 2680  .CATEG_BASE=BT_ECR(20,20)
 2690  .DATE_DEBUT_BASE=VALUE(BT_ECR(21,28))
 2700  .!!
 2710  .!!
 2720  .CLEAR TABLES_NAMES,TAUX_BT_OUT,LOUT,DOUT,NOUT,SOUT,COUT,MOUT,ROUT,VOUT
 2730  .PROGRAM DLTABBT("DLTABBT","GROUPE")
 2731  .SHOW"AVANT DLTABBT ... TYPE BASE=";TYPE_BASE;"KEY BASE=";KEY_BASE
 2732  .SHOW"GARANTI BASE=";GARANTI_BASE;"PUPP BASE=";PUPP_BASE
 2733  .SHOW"CATEG BASE=";CATEG_BASE;"DATE DEBUT BASE=";DATE_DEBUT_BASE
 2734  .SHOW"TABLES NAME=";TABLES_NAME;"TAUX PB OUT=";TAUX_BT_OUT
 2735  .WAIT
 2740  .DO DLTABBT(TYPE_BASE,KEY_BASE,GARANTI_BASE,PUPP_BASE,
 2750  .''CATEG_BASE,DATE_DEBUT_BASE,TABLES_NAME,TAUX_BT_OUT,
 2760  .''LOUT,DOUT,NOUT,SOUT,COUT,MOUT,ROUT,VOUT)
 2761  .SHOW"APRES DLTABBT ... "
 2762  .SHOW"LOUT(3) ";LOUT(3);" DOUT(3) ";DOUT(3);" NOUT(3) ";NOUT(3);
 2765  .WAIT
 2770  .DO VIEW_RD_DOSSIER:!! ("RD_GROUPE_DOSSIER")
 2780  .DO GETFIRST_RD_DOSSIER_3(NUMERO_EMPL_HPLC,DT_NAIS_AFF_HPLC,CKDG_POL_HPLC)
 2790  .TARIF=CODE_TARIF_HPLC
 2800  .NO_EMPL=NUMERO_EMPL_HPLC
 2810  .OPTION=1
 2820  .CAPITAL=0
 2830  .SOMME=0
 2840  .PRICO=0
 2850  .AGEA=0
 2860  .AGEM=0
 2870  .D_CALC=DT_EFFET_MOD
 2880  .!!
 2890  .!!   CALCUL DE L''AGE DE L''AFFILIE
 2900  .!!
 2910  .PROGRAM DLPRTAGE("DLPRTAGE","GROUPE")
 2920  .DO DLPRTAGE(DATE_NAISS_AFF,D_CALC,AGEA,AGEM)
 2930  .RELEASE DLPRTAGE
 2940  .XA=AGEA
 2950  .AGE_AFFILIE=AGEA
 2960  .AGE_AFF_AA=AGEA
 2970  .AGE_AFF_MM=AGEM
 2980  .XM=AGEM
 2990  .AGE_AFFILIE_M=AGEM
 3000  .AGE_CONJ_AA=0
'
		! !

!SpecDuplicationInspectorDynamic methodsFor: 'protocol' stamp: 'ub 11/13/2012 16:22'!
title
	^ self cloneFragmentsTree selectedItem
		ifNil: [ 'Duplication Inspector' ]
		ifNotNil: [:anItem|  'Duplication Inspector -> ' , anItem name ]! !

!SpecDuplicationInspectorDynamic methodsFor: 'checkbox' stamp: 'ub 11/15/2012 11:55'!
wrap: item
	| checkBox |
	checkBox := self instantiate: CheckBoxModel.
	checkBox label: (item).
	checkBox whenActivatedDo: [ 
		self selectedItems add: item.
		self redrawBrowser.
		
		 ].
	
	checkBox whenDesactivatedDo: [ 
		self selectedItems remove: item.
		self redrawBrowser.
		
		 ].
	^ checkBox! !

ListComposableModel subclass: #TaggedList
	instanceVariableNames: 'entities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpecDuplicationInspector'!

!TaggedList methodsFor: 'as yet unclassified' stamp: 'ub 11/15/2012 16:08'!
alignmentMorph
		^ AlignmentMorph new
				listDirection: #leftToRight;
				borderWidth: 0;
				color: Color transparent;
				vResizing: #shrinkWrap;
				hResizing: #shrinkWrap;
				layoutInset: 1;
				wrapCentering: #center;
				cellPositioning: #center.	! !

!TaggedList methodsFor: 'accessing' stamp: 'ub 11/15/2012 16:08'!
entities
	^ entities! !

!TaggedList methodsFor: 'accessing' stamp: 'ub 11/15/2012 16:08'!
entities: anObject
	entities := anObject! !

!TaggedList methodsFor: 'as yet unclassified' stamp: 'ub 11/15/2012 16:15'!
getListOfEntities
	
	^ self entities collect: [:each | 
		|morph|
		morph := self alignmentMorph.
		morph
			addMorphBack: 
				(StringMorph new
					contents: each asString).
		morph 
			addMorphBack: (self glamourStyleButtonLabeled: 10 asString); position: 3@3;
			addMorphBack: (self glamourStyleButtonLabeled: 60 asString); position: 3@3.
			morph
		
			
			]! !

!TaggedList methodsFor: 'as yet unclassified' stamp: 'ub 11/15/2012 16:14'!
getListOfFilteredEntities
	
	^ self entities collect: [:each | 
		|morph|
		morph := self alignmentMorph.
		morph
			addMorphBack: 
				(StringMorph new
					contents: each asString).
		morph addMorphBack: (self glamourStyleButtonLabeled: 'To Do'); position: 3@3.
		morph 
			addMorphBack: (self glamourStyleButtonLabeled: 10 asString); position: 3@3;
			addMorphBack: (self glamourStyleButtonLabeled: 6 asString); position: 3@3.
			morph
		
			
			]! !

!TaggedList methodsFor: 'as yet unclassified' stamp: 'ub 11/15/2012 16:08'!
glamourStyleButtonLabeled: aString
	
	| button stringMorph|
	button := SimpleButtonMorph new label: '' .
	stringMorph := (StringMorph contents: aString
					font: (LogicalFont 
						 	familyName: UITheme current buttonFont familyName
							pointSize: UITheme current buttonFont pointSize -2)) color: Color white; yourself.
	button addMorph: stringMorph.				
	button useRoundedCorners; 
			borderColor: Color transparent; 
			color: Color lightGray;
			extent: (stringMorph width + 6) @ (stringMorph height + 6) .
	stringMorph position: 3 @3; lock.
	^button! !

Object subclass: #DupInspectorLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpecDuplicationInspector'!

!DupInspectorLayout class methodsFor: 'as yet unclassified' stamp: 'ub 11/15/2012 18:06'!
buildFixPart: aRow
	| height |
	height := StandardFonts defaultFont height + 3.
	aRow newColumn: [:c | 
		c
			add: #dropList height:20;
			add: #listLabel height:20;
			add: #cloneFragmentsTree] width: 250.
	aRow addSplitter.! !

!DupInspectorLayout class methodsFor: 'as yet unclassified' stamp: 'ub 11/22/2012 17:47'!
dynSpecLayoutWith: selectedItems
	^ SpecLayout composed
		newRow: [:row | 
			self buildFixPart: row.
			row newRow:[:r |
			1 to: selectedItems size do: [:idx | 
					r add: (('col', idx asString) asSymbol) ]]
		].! !

!DupInspectorLayout class methodsFor: 'as yet unclassified' stamp: 'ub 11/15/2012 17:01'!
initialLayout
	<spec: #default>
	^ SpecLayout composed
		newRow: [:row | 
			self buildFixPart: row.
			row newColumn: [:c | c  add: #fileContainer]
		];
		
		yourself.! !
